From f49f0ce5d9e6343abfd5f38235ba56001b673489 Mon Sep 17 00:00:00 2001
From: Veerabhadrarao Badiganti <vbadigan@codeaurora.org>
Date: Fri, 22 Feb 2019 10:45:55 +0530
Subject: [PATCH 06/13] storage: Use gpio based card detection to check card
 presence

Use gpio based card detction mechanism to check the card presence
for removable cards. If cd-gpio is supplied, use it for card
detection else continue using present state register.

Change-Id: I6ad405301c19d3409ed0ba91e0bbe3c06048eb7b
Signed-off-by: Veerabhadrarao Badiganti <vbadigan@codeaurora.org>
---
 src/drivers/storage/sdhci.c | 7 ++++++-
 src/drivers/storage/sdhci.h | 3 +++
 2 files changed, 9 insertions(+), 1 deletion(-)

diff --git a/src/drivers/storage/sdhci.c b/src/drivers/storage/sdhci.c
index ab8caa5e3b0d..f04c9b5119b6 100644
--- a/src/drivers/storage/sdhci.c
+++ b/src/drivers/storage/sdhci.c
@@ -789,7 +789,12 @@ static int sdhci_update(BlockDevCtrlrOps *me)
 		(me, SdhciHost, mmc_ctrlr.ctrlr.ops);
 
 	if (host->removable) {
-		int present = (sdhci_readl(host, SDHCI_PRESENT_STATE) &
+		int present;
+
+		if (host->cd_gpio)
+			present = gpio_get(host->cd_gpio);
+		else
+			present = (sdhci_readl(host, SDHCI_PRESENT_STATE) &
 			       SDHCI_CARD_PRESENT) != 0;
 
 		if (!present) {
diff --git a/src/drivers/storage/sdhci.h b/src/drivers/storage/sdhci.h
index 9e0c3f64d4e0..c0e88b95c123 100644
--- a/src/drivers/storage/sdhci.h
+++ b/src/drivers/storage/sdhci.h
@@ -24,6 +24,7 @@
 #include <libpayload.h>
 
 #include "mmc.h"
+#include "drivers/gpio/gpio.h"
 
 /*
  * Controller registers
@@ -314,6 +315,8 @@ struct sdhci_host {
 	/* Number of ADMA descriptors currently in the array. */
 	int adma_desc_count;
 
+	GpioOps *cd_gpio; /*card detect GPIO */
+
 	int (*attach)(SdhciHost *host);
 	void (*set_control_reg)(SdhciHost *host);
 };
-- 
The Qualcomm Innovation Center, Inc. is a member of the Code Aurora Forum,
a Linux Foundation Collaborative Project

